'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var REGEX_TENANT = /^([^_]+)_.*$/;

var clientsFetchTenants = {
  mysql: function mysql(knex) {
    return knex.raw('\n      SELECT table_name\n      FROM information_schema.tables\n      WHERE table_schema = (SELECT database())\n        AND table_name LIKE \'%_knex_migrations\'\n    ').then(function (_ref) {
      var _ref2 = (0, _slicedToArray3.default)(_ref, 1),
          rows = _ref2[0];

      return rows.map(function (row) {
        return row.table_name;
      });
    });
  },
  pg: function pg(knex) {
    return knex.raw('\n      SELECT table_name\n      FROM information_schema.tables\n      WHERE table_schema = (SELECT current_schema())\n        AND table_name LIKE \'%_knex_migrations\'\n    ').then(function (_ref3) {
      var rows = _ref3.rows;
      return rows.map(function (row) {
        return row.table_name;
      });
    });
  }
};

/**
 * Fetch all the tenants available in the current DB.
 **/

exports.default = function () {
  var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(knex) {
    var client, fetchTenants, tables;
    return _regenerator2.default.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            client = knex.client.config.client;
            fetchTenants = clientsFetchTenants[client];

            if (fetchTenants) {
              _context.next = 4;
              break;
            }

            throw new Error('Current client ' + client + ' has no support yet to fetch the tenant ids.');

          case 4:
            _context.next = 6;
            return fetchTenants(knex);

          case 6:
            tables = _context.sent;
            return _context.abrupt('return', tables.map(function (table) {
              return table.replace(REGEX_TENANT, '$1');
            }));

          case 8:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this);
  }));

  return function (_x) {
    return _ref4.apply(this, arguments);
  };
}();